#ifndef LIFT_H
#define LIFT_H

#define LIFT_TYPE	14
#define LIFT_NAME	"Lift"
#define	LIFT_INIT	liftInitFuncList
#define LIFT_PROPS	2
#define LIFT_LASTING	10.0	/* 10 sec */

#define LIFT_PROPZ	0
#define LIFT_PROPHNAME	1

#define LIFT_INCRZ	0.01	/* 1 cm */
#define LIFT_DENSITY	10.0


class Lift: public WObject {
public:
  int   org_l;		// origine low
  float speed;
  float height;
  float dest;		// destination
  u_int8 levels;
  u_int8 carry;
  u_int8 weight;
  User *user;

  static const WClass wclass;	// class variable
  virtual const WClass* getWClass() {return &wclass;};  //virtual inst. method

  Lift(char *l);

  static void (creator)(char *l);
  virtual boolean change();
  virtual void changePosition(float lasting);
  virtual void updateTime(time_t, time_t, float *);
  virtual boolean updateToNetwork(const Pos &oldpos);
  virtual void whenIntersect(WObject *pcur, WObject *pold);
  virtual void whenNoIntersect(WObject *pcur, WObject *pold);
  virtual void quit();
};

void LIFT_INIT(void);

#endif /* LIFT_H */
